/* io.h - I/O operations */
 
/* Written 11-1997 by Mohsen.Souissi@inria.fr, INRIA */
 

#ifndef IO_H
#define IO_H

#define MAX_SAP 1

extern struct sap_addr local_sap[MAX_SAP];
extern int sig_sd;
extern struct atm_qos qos_default_p2p, qos_default_p2m;
extern int active;
extern int inatmarp_dump;
extern const char *as_name[];

struct sap_addr *get_sap(u_char *aesa, u_char sel);
void init_addr(void);
int open_atmsigd(void);
void init_current_time(void);
int atm_cac(struct atmsvc_msg *msg);

#define msg2bllis(s) (((int) (s)-(int) sizeof(struct atmsvc_msg))/ \
  (int) sizeof(struct atm_blli)+1)
#define bllis2msg(n) (sizeof(struct atmsvc_msg)+sizeof(struct atm_blli)*((n)-1))

int dispatch(struct atmsvc_msg *msg, ATMCALL *callarg, PARTY *partyarg);
int from_atmsigd(struct atmsvc_msg *msg, ATMCALL *callarg, PARTY *partyarg);
int recv_atmsigd(ATMCALL *callarg, PARTY *partyarg);
int send_atmsigd(u_long vcc, u_long listen_vcc, short ep_ref,
		  enum atmsvc_msg_type type, int reply, 
		  const struct sap_addr *svc, const struct sap_addr *local, 
		  const struct atm_qos *qos);
int to_atmsigd(struct atmsvc_msg *msg);

int recv_natm_peer(ATMCALL *call, int dump);

const char *mid2name(u_char mid);

int poll_atmsigd(ATMCALL *callarg, PARTY *partyarg);
int poll_loop(void);
#endif
